import <zlib.ash>
/*
OCD Inventory Control Storm Knight Edition v1

Script by Bale
http://kolmafia.us/showthread.php?t=1818&highlight=inventory+control%5C
Storm Knight Modifications by That FN Ninja

The intent of this script is to clean out your inventory.

Please note that this also cleans out Hangks, your closet, and even currently 
equipped items! Hence the OCD.

If you have not configured the "OCD Data Creator SKE.ash" please do
so before running this script. The "OCD Data Creator SKE.ash" creates an 
"OCD Data SKE.txt" witch holds a list of all items to send to the treasury, mallsell, 
pulverize, or keep. The associated int in the "OCD Data Ceator SKE.ash" is how many of them 
to keep. If the value is -1 or less, none will be disposed of.
*/

// If this is true, the script won't actually do anything. It'll only TELL you what it would do.
boolean simulation = true;

//Tells the script whether to donate of sell stuff to the treasury.
//If you have more of an item than you have said you wanted to keep or if an item is 
//not listed in the "OCD Data Creator SKE.ash" the script does what you tell it to here.
string donate_or_sell = "donate";

//This will donate to the treasury until the donation total = donate_to and then sells the rest.
//Make sure donate_or_sell is set to "sell" to utilize this feature.
//Basically this number is the amount of credit you wish to gain before selling.
//Please note that this number does not take into account the credit you have already accumulated.
int donate_to = 50000;

//If this is true everything in your closet will be left alone.
boolean ignore_closet = false;
//If this is true everything in Hangks will be left alone.
boolean ignore_hangks = false;
//If this is true and you have keys it will make key lime pies out of them.
boolean make_pies = true;

//If this is true, items that clannies collect will be sent to them.
//Please check the items they'd be recieving to make sure you're okay with it.
boolean clan_collectors = false;
	//List of clannies that said they are collecting.
	//A list of specific items can be found a little further down the script.
	boolean Zarqon = true;         	//Lots of really cheap stuff with the word "bat" in it.
	boolean Kaluna = true;       	//rogue swarmer, shimmering rainbow sand, golden ring, toast
	boolean Macatoni = true;      	//diamond, spade, club, and heart necklaces from the Mr. Klaw
	boolean Sam_l_Am = true; 		//vodka gibson, rockin' wagon with a fly in it
	boolean ThatFNNinja = true;	//Lots of stuff with the word ninja in it.

	
//If this is true the outfit you are wearing when you first run this script while be restored after it's done. 
//This is nice for periodic aftercore usage...
boolean restore_outfit = true;

item fam_equip;
if(restore_outfit) {
	fam_equip = familiar_equipped_equipment(my_familiar());
	cli_execute("outfit save Backup");
}	
	
if(simulation)
	print("---SIMULATING---","red");
	
//First empty out Hangks, so it can be accounted for by what follows.
if(!ignore_hangks)
	visit_url("storage.php?action=takeall&pwd");
//Now strip, so I can dispose of everything.
cli_execute("outfit birthday suit");

//List of clan collectors items. Note that you can individually enable/disable a specific 
//person above or you can disable a particular item by commenting out it's line below.
if(clan_collectors){
	print("");
	print("Sending clan collectors items...","blue");
	if(Zarqon){
		int[item] gifts;
		//Goodies for Zarqon
		gifts[$item[bat wing]] = item_amount($item[bat wing]);
		gifts[$item[bat wing kabob]] = item_amount($item[bat wing kabob]);
		gifts[$item[batblade]] = item_amount($item[batblade]);
		gifts[$item[bat guano]] = item_amount($item[bat guano]);
		gifts[$item[batgut]] = item_amount($item[batgut]);
		gifts[$item[leathery bat skin]] = item_amount($item[leathery bat skin]);
		print("Sending the following to Zarqon:");
		foreach itm,amt in gifts
			if(item_amount(itm) > 0)
				print(amt+" "+itm,"blue");
		if(!simulation)
			kmail("Zarqon","For your collection! :D",0,gifts);
	}
	if(Kaluna){
		int[item] gifts;
		//Goodies for Kaluna
		gifts[$item[rogue swarmer]] = item_amount($item[rogue swarmer]);
		gifts[$item[shimmering rainbow sand]] = item_amount($item[shimmering rainbow sand]);
		gifts[$item[golden ring]] = item_amount($item[golden ring]);
		gifts[$item[toast]] = item_amount($item[toast]);
		print("Sending the following to Kaluna:");
		foreach itm,amt in gifts
			if(item_amount(itm) > 0)
				print(amt+" "+itm,"blue");
		if(!simulation)
			kmail("Kaluna","For your collection! :D",0,gifts);
	}
	if(Macatoni){
		int[item] gifts;
		//Goodies for Macatoni
		gifts[$item[heart necklace]] = item_amount($item[heart necklace]);
		gifts[$item[club necklace]] = item_amount($item[club necklace]);
		gifts[$item[spade necklace]] = item_amount($item[spade necklace]);
		gifts[$item[diamond necklace]] = item_amount($item[diamond necklace]);
		print("Sending the following to Macatoni:");
		foreach itm,amt in gifts
			if(item_amount(itm) > 0)
				print(amt+" "+itm,"blue");
		if(!simulation)
			kmail("Macatoni","For your collection! :D",0,gifts);
	}
	if(Sam_l_Am){
		int[item] gifts;
		//Goodies for Sam_l_Am
		gifts[$item[vodka gibson]] = item_amount($item[vodka gibson]);
		gifts[$item[rockin' wagon with a fly in it]] = item_amount($item[rockin' wagon with a fly in it]);
		print("Sending the following to Sam_l_Am:");
		foreach itm,amt in gifts
			if(item_amount(itm) > 0)
				print(amt+" "+itm,"blue");
		if(!simulation)
			kmail("Sam_l_Am","For your collection! :D",0,gifts);
	}
	if(ThatFNNinja){
		int[item] gifts;
		//Goodies for That FN Ninja
		gifts[$item[stuffed ninja snowman]] = item_amount($item[stuffed ninja snowman]);
		gifts[$item[tiny plastic ninja snowman]] = item_amount($item[tiny plastic ninja snowman]);
		gifts[$item[tiny plastic demoninja]] = item_amount($item[tiny plastic demoninja]);
		gifts[$item[ridiculously overelaborate ninja weapon]] = item_amount($item[ridiculously overelaborate ninja weapon]);
		gifts[$item[sweet ninja sword]] = item_amount($item[sweet ninja sword]);
		gifts[$item[frigid ninja stars]] = item_amount($item[frigid ninja stars]);
		print("Sending the following to That FN Ninja:");
		foreach itm,amt in gifts
			if(item_amount(itm) > 0)
				print(amt+" "+itm,"blue");
		if(!simulation && count(gifts) > 0)
			kmail("That FN Ninja","For your collection! :D",0,gifts);
	}
}

//Treasury Functions
string url = visit_url("showplayer.php?who=1649736");
int tmeat = substring(url,index_of(url,"Meat:")+18,index_of(url,"ascensionhistory")-56).to_int();
boolean topen(){
	if(contains_text(url,"(Hardcore)") || contains_text(url,"(In Ronin)"))
		return false;
	return true;
}

//Make pies and use gift certificates and meat items.
print("");
print("Making pies and using meat items...","blue");
if(!simulation){
	if(make_pies){
		create(item_amount($item[Boris's key]), $item[Boris's key lime pie]);
		create(item_amount($item[Jarlsberg's key]), $item[Jarlsberg's key lime pie]);
		create(item_amount($item[Sneaky Pete's key]), $item[Sneaky Pete's key lime pie]);
		create(item_amount($item[digital key]), $item[digital key lime pie]);
		create(item_amount($item[Richard's star key]), $item[star key lime pie]);
	}
	foreach itm in $items[black pension check,Warm Subject gift certificate,old coin purse,old leather wallet,ancient vinyl coin purse,briefcase,duct tape wallet,fat wallet]
		if(item_amount(itm) > 0)
			use(item_amount(itm),itm);
}

//Now strip, so I can dispose of everything (bugbear outfit might have been equipped by the above).
cli_execute("outfit birthday suit");

print("");
cli_execute("call OCD Data Creator SKE.ash");
print("");
record item_disposal{int q; string action;};
item_disposal[item] ocd;
file_to_map("OCD Data SKE.txt",ocd);

int[item] treasury_sell,treasury_donate;
int mall_q,mall_line,auto_q,auto_line,pulv_q,pulv_line,price,mall_total,auto_total,tdonate_total,tsell_total;
string[int] mall,auto,pulv;

print("Checking inventory items and prices...","blue");
print("Please be patient. This could take awhile.","red");
foreach it in $items[]{
	if(is_tradeable(it) && item_amount(it) > 0){
		if(!ignore_closet && closet_amount(it) > 0)
			take_closet(closet_amount(it),it);
		if(item_amount(it) > 0){
			if(ocd contains it){
				if(ocd[it].q < 0)
					continue;
				if(ocd[it].action == "treasury" && item_amount(it) > ocd[it].q){
					price = mall_price(it);
					if(donate_to > 0 && tdonate_total < donate_to || donate_or_sell == "donate"){
						tdonate_total = price * (item_amount(it)-ocd[it].q) + tdonate_total;
						treasury_donate[it] = item_amount(it)-ocd[it].q;
					}
					else{
						tsell_total = (price * (item_amount(it)-ocd[it].q)) - (price * .05 * (item_amount(it)-ocd[it].q)) + tsell_total;
						treasury_sell[it] = item_amount(it)-ocd[it].q;
					}
				}
				if(ocd[it].action == "mall" && item_amount(it) > ocd[it].q){
					if(mall_q != 0)
						mall[mall_line] = mall[mall_line] + ", ";
					price = mall_price(it);
					mall_total = price * (item_amount(it)-ocd[it].q) + mall_total;
					mall[mall_line] = mall[mall_line] + to_string(item_amount(it)-ocd[it].q)+ " "+to_string(it)+ " @ "+to_string(price);
					mall_q = mall_q + 1;
					if(mall_q == 11){
						mall_line = mall_line +1;
						mall_q = 0;
					}
				}
				if(ocd[it].action == "pulverize" && item_amount(it) > ocd[it].q){
					if(pulv_q != 0)
						pulv[pulv_line]= pulv[pulv_line] + ", ";
					pulv[pulv_line] = pulv[pulv_line] + to_string(item_amount(it)-ocd[it].q)+ " "+to_string(it);
					pulv_q = pulv_q + 1;
					if(pulv_q == 11) {
						pulv_line = pulv_line +1;
						pulv_q = 0;
					}
				}
			} 
			else{
				price = mall_price(it);
				if(donate_to > 0 && tdonate_total < donate_to || donate_or_sell == "donate"){
					tdonate_total = price * (item_amount(it)-ocd[it].q) + tdonate_total;
					treasury_donate[it] = item_amount(it)-ocd[it].q;
				}
				else{
					tsell_total = (price * (item_amount(it)-ocd[it].q)) - (price * .05 * (item_amount(it)-ocd[it].q)) + tsell_total;
					treasury_sell[it] = item_amount(it)-ocd[it].q;
				}
			}
		}
	}
	else if(ocd contains it && ocd[it].action == "autosell" && item_amount(it) > ocd[it].q){
		if(auto_q != 0)
			auto[auto_line]= auto[auto_line] + ", ";
		auto_total = autosell_price(it) * (item_amount(it)-ocd[it].q) + auto_total;
		auto[auto_line] = auto[auto_line] + to_string(item_amount(it)-ocd[it].q)+ " "+to_string(it);
		auto_q = auto_q + 1;
		if(auto_q == 11){
			auto_line = auto_line +1;
			auto_q = 0;
		}	
	}
}

foreach itm,amt in treasury_donate{
	print("Donate "+amt+" "+itm+" to the treasury.","blue");
	//if(mall_price(itm) > 5000)
		//print(itm+" is selling for "+mall_price(itm));
}
foreach itm,amt in treasury_sell
	print("Sell "+amt+" "+itm+" to the treasury.","blue");
if(!simulation && topen()){
	print("");
	print("Sending items...");
	print("Please be patient. This could take awhile.","red");
	if(count(treasury_donate) > 0)
		kmail("Sir William de Ros","",0,treasury_donate);
	if(tsell_total > tmeat){
		print("");
		print("You are attempting to sell more items to the Treasury than Sir William has liquid meat on hand to cover!","red");
		print("The Treasury has "+tmeat+" and you are trying to sell "+tsell_total+" worth of items.");
		print("Either adjust your donation setting to get more credit or wait until the Treasury has more liquid meat.");
	}
	else if(count(treasury_sell) > 0)
		kmail("Sir William de Ros","sell",0,treasury_sell);
	print("Items sent!","green");
}
if(auto[0].length() != 0){
	print("");
	foreach key in auto{
		print("autosell "+auto[key],"blue");
		if(!simulation)
			cli_execute("autosell "+auto[key]);
	}
}
if(mall[0].length() != 0)
	print("");
	foreach key in mall{
		print("mallsell "+mall[key],"blue");
		if(!simulation)
			cli_execute("mallsell "+mall[key]);
	}
if(pulv[0].length() != 0)
	print("");
	foreach key in pulv{
		print("pulverize "+pulv[key],"blue");
		if(!simulation)
			cli_execute("pulverize "+pulv[key]);
	}
	
print("");	
if(!topen()){
	print("The Treasury is closed. Nothing can be donated or sold at this time.","red");
	print("Sir Willam is either in Hardcore or under Ronin restrictions.");
	print("");
}	
if(auto_total > 0)
	print_html("<b>Total autosell value: <font color=0033FF>"+auto_total+"</font></b>");
if(mall_total > 0)
	print_html("<b>Total mall value: <font color=0033FF>"+mall_total+"</font></b>");
if(tdonate_total > 0)
	print_html("<b>Estimated credit increase: <font color=0033FF>"+tdonate_total+"</font></b>");
if(tsell_total > 0)
	print_html("<b>Estimated meat from treasury sells: <font color=0033FF>"+tsell_total+"</font></b>");
print("");

if(restore_outfit){
	outfit("Backup");
	if(fam_equip != $item[none])
		equip($slot[familiar],fam_equip);
}

//Since a lot of price data was just garnered...
cli_execute("spade prices http://zachbardon.com/mafiatools/updateprices.php");

if(simulation)
	print("This was only a test. Had this been an actual OCD incident your inventory would be clean right now.","green");
else 
	print("This inventory is clean.","green");
